=== debian/changelog ===
mlpack (3.3.2-5) unstable; urgency=medium

  * refine build dependency on clang and julian where available

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 09 Aug 2020 18:33:10 +0100

mlpack (3.3.2-4) unstable; urgency=medium

  * fix broken debian/rules executable search non-POSIX logic

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 08 Aug 2020 22:13:47 +0100

mlpack (3.3.2-3) unstable; urgency=medium

  * hotwire debian/rules to check for clang and use it iff found
  * hotwire debian/rules to check for julia and support it iff found
  * make clang and julia optional build dependencies by giving them each
    a minimal dummy alternative

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 08 Aug 2020 21:36:45 +0100

mlpack (3.3.2-2) unstable; urgency=medium

  * include cmake support files in development package (closes: #964294)
  * update configuration options, including enabling building of tests
  * enable Julia bindings
  * avoid compile-time resource exhaustion by using CLANG instead of GCC
    (closes: #962533)
  * quilt patch for build-killing LaTeX markup typo
  * install stray html support file
  * Now formula.repository is gone, huh

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 04 Aug 2020 13:39:14 +0100

mlpack (3.3.2-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 28 Jun 2020 16:09:45 +0100
